VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cDlgCom"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"

Option Explicit
'// ********** ELABORE AVEC C2IEXPLORER ******************
'// richard.clark@wanadoo.fr
'// http://pro.wanadoo.fr/c2i
'// version complte par jean-luc@delbeke.fr en mai 2002
'// http://www.delbeke.fr
'//*****************************************************

'//*********************************
' variables internes
'//*********************************
Private sFileName As String 'nom du fichier
Private sFileTitle As String    'titre du fichier
Private sDefaultEx As String    'extension par default
Private sInitDir As String  'rpertoire d'ouverture
Private lngFilterIndex As Long  'index du filtre
Private sFilter As String   'filtre
Private lnghWndOwner As Long 'propritaire de la boite de dialogue
Private lngFlags As Long        'les flags
Private sDialogTitle As String  'titre de la boite de dialogue
Private sFolder As String   'le dossier du fichier
Private lngColor As OLE_COLOR
Private sFontName As String
Private sngFontSize As Long
Private bFontBold As Boolean
Private bFontItalic As Boolean
Private bFontUnderline As Boolean
Private bFontStrikethru As Boolean
Private lMinPage As Long
Private lMaxPage As Long
Private lFromPage As Long
Private lToPage As Long
Private lCopies As Long
Private lPaperSize As Long
Private lDuplex As Long
Private lPaperBin As Long
Private lOrientation As Long
Private lPrintQuality As Long
Private lColorMode As Long
Private sPrinterName As String
'//*********************************
'Dclarations pour boite rpertoire
'//*********************************
Private Const BIF_RETURNONLYFSDIRS = 1
Private Const BIF_DONTGOBELOWDOMAIN = 2

Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long

Private Type BrowseInfo
    hwndOwner      As Long
    pIDLRoot       As Long
    pszDisplayName As Long
    lpszTitle      As Long
    ulFlags        As Long
    lpfnCallback   As Long
    lParam         As Long
    iImage         As Long
End Type
'//*********************************
'Dclarations pour boite open et save
'//*********************************
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

Private Type OPENFILENAME
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        nFilterIndex As Long
        lpstrFile As String
        nMaxFile As Long
        lpstrFileTitle As String
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
        flags As Long
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As String
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type

'//*********************************
'Dclarations pour boite ShowColor
'//*********************************
Private Declare Function CHOOSECOLOR Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As CHOOSECOLOR) As Long
Private Type CHOOSECOLOR
   lStructSize As Long
   hwndOwner As Long
   hInstance As Long
   rgbResult As Long
   lCustColors As Long
   flags As Long
   lCustData As Long
   lpfnHook As Long
   lpTemplateName As String
End Type
 
'//*********************************
'Dclarations pour boite ShowFont
'//*********************************
Const FW_NORMAL = 400
Const DEFAULT_CHARSET = 1
Const OUT_DEFAULT_PRECIS = 0
Const CLIP_DEFAULT_PRECIS = 0
Const DEFAULT_QUALITY = 0
Const DEFAULT_PITCH = 0
Const FF_ROMAN = 16
Const REGULAR_FONTTYPE = &H400
Const LF_FACESIZE = 32
Const CCHDEVICENAME = 32
Const CCHFORMNAME = 32

Private Declare Function CHOOSEFONT Lib "comdlg32.dll" Alias "ChooseFontA" (pChoosefont As CHOOSEFONT) As Long
Private Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName As String * 31
End Type
Private Type CHOOSEFONT
        lStructSize As Long
        hwndOwner As Long          '  caller's window handle
        hDC As Long                '  printer DC/IC or NULL
        lpLogFont As Long          '  ptr. to a LOGFONT struct
        iPointSize As Long         '  10 * size in points of selected font
        flags As Long              '  enum. type flags
        rgbColors As Long          '  returned text color
        lCustData As Long          '  data passed to hook fn.
        lpfnHook As Long           '  ptr. to hook function
        lpTemplateName As String     '  custom template name
        hInstance As Long          '  instance handle of.EXE that
                                       '    contains cust. dlg. template
        lpszStyle As String          '  return the style field here
                                       '  must be LF_FACESIZE or bigger
        nFontType As Integer          '  same value reported to the EnumFonts
                                       '    call back with the extra FONTTYPE_
                                       '    bits added
        MISSING_ALIGNMENT As Integer
        nSizeMin As Long           '  minimum pt size allowed &
        nSizeMax As Long           '  max pt size allowed if
                                       '    CF_LIMITSIZE is used
End Type
'//*********************************
'Dclarations pour boite ShowPrinter
'//*********************************
Const DM_DUPLEX = &H1000&
Const DM_ORIENTATION = &H1&

Private Type PRINTDLG_TYPE
    lStructSize As Long
    hwndOwner As Long
    hDevMode As Long
    hDevNames As Long
    hDC As Long
    flags As Long
    nFromPage As Integer
    nToPage As Integer
    nMinPage As Integer
    nMaxPage As Integer
    nCopies As Integer
    hInstance As Long
    lCustData As Long
    lpfnPrintHook As Long
    lpfnSetupHook As Long
    lpPrintTemplateName As String
    lpSetupTemplateName As String
    hPrintTemplate As Long
    hSetupTemplate As Long
End Type
Private Type DEVNAMES_TYPE
    wDriverOffset As Integer
    wDeviceOffset As Integer
    wOutputOffset As Integer
    wDefault As Integer
    extra As String * 100
End Type
Private Type DEVMODE_TYPE
    dmDeviceName As String * CCHDEVICENAME
    dmSpecVersion As Integer
    dmDriverVersion As Integer
    dmSize As Integer
    dmDriverExtra As Integer
    dmFields As Long
    dmOrientation As Integer
    dmPaperSize As Integer
    dmPaperLength As Integer
    dmPaperWidth As Integer
    dmScale As Integer
    dmCopies As Integer
    dmDefaultSource As Integer
    dmPrintQuality As Integer
    dmColor As Integer
    dmDuplex As Integer
    dmYResolution As Integer
    dmTTOption As Integer
    dmCollate As Integer
    dmFormName As String * CCHFORMNAME
    dmUnusedPadding As Integer
    dmBitsPerPel As Integer
    dmPelsWidth As Long
    dmPelsHeight As Long
    dmDisplayFlags As Long
    dmDisplayFrequency As Long
End Type
Private Declare Function PrintDialog Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintdlg As PRINTDLG_TYPE) As Long

  
'//************************
'Contantes
'//************************
Public Enum CdlgConst

  OF_CANCEL = &H800
  OF_CREATE = &H1000
  OF_DELETE = &H200
  OF_EXIST = &H4000
  OF_PROMPT = &H2000
  OF_READ = &H0
  OF_READWRITE = &H2
  OF_REOPEN = &H8000
  OF_SHARE_COMPAT = &H0
  OF_SHARE_DENY_NONE = &H40
  OF_SHARE_DENY_READ = &H30
  OF_SHARE_DENY_WRITE = &H20
  OF_SHARE_EXCLUSIVE = &H10
  OF_VERIFY = &H400
  OF_WRITE = &H1
  OFN_ALLOWMULTISELECT = &H200
  OFN_CREATEPROMPT = &H2000
  OFN_ENABLEHOOK = &H20
  OFN_ENABLETEMPLATE = &H40
  OFN_ENABLETEMPLATEHANDLE = &H80
  OFN_EXPLORER = &H80000
  OFN_EXTENSIONDIFFERENT = &H400
  OFN_FILEMUSTEXIST = &H1000
  OFN_HIDEREADONLY = &H4
  OFN_LONGNAMES = &H200000
  OFN_NOCHANGEDIR = &H8
  OFN_NODEREFERENCELINKS = &H100000
  OFN_NOLONGNAMES = &H40000
  OFN_NONETWORKBUTTON = &H20000
  OFN_NOREADONLYRETURN = &H8000
  OFN_NOTESTFILECREATE = &H10000
  OFN_NOVALIDATE = &H100
  OFN_OVERWRITEPROMPT = &H2
  OFN_PATHMUSTEXIST = &H800
  OFN_READONLY = &H1
  OFN_SHAREAWARE = &H4000
  OFN_SHAREFALLTHROUGH = 2
  OFN_SHARENOWARN = 1
  OFN_SHAREWARN = 0
  OFN_SHOWHELP = &H10

  CC_ANYCOLOR = &H100
  CC_ENABLEHOOK = &H10
  CC_ENABLETEMPLATE = &H20
  CC_FULLOPEN = &H2
  CC_PREVENTFULLOPEN = &H4
  CC_RGBINIT = &H1
  CC_SHOWHELP = &H8
  CC_SOLIDCOLOR = &H80
  
  CF_PRINTERFONTS = &H2
  CF_SCREENFONTS = &H1
  CF_BOTH = (CF_SCREENFONTS Or CF_PRINTERFONTS)
  CF_EFFECTS = &H100&
  CF_FORCEFONTEXIST = &H10000
  CF_INITTOLOGFONTSTRUCT = &H40&
  CF_LIMITSIZE = &H2000&
  
  PD_ALLPAGES = &H0
  PD_COLLATE = &H10
  PD_DISABLEPRINTTOFILE = &H80000
  PD_HELPBUTOON = &H800
  PD_HIDEPRINTTOFILE = &H100000
  PD_NOPAGENUMS = &H8
  PD_NOSELECTION = &H4
  PD_NOWARNING = &H80
  PD_PAGENUMS = &H2
  PD_PRINTSETUP = &H40
  PD_PRINTTOFILE = &H20
  PD_RETURNDC = &H100
  PD_RETURNDEFAULT = &H400
  PD_RETURNIC = &H200
  PD_SELECTION = &H1
  PD_USEDEVMODECOPIES = &H40000
End Enum
'//*********************************
'Dclarations pour gestion mmoire
'//*********************************
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)

Private Const GMEM_MOVEABLE = &H2
Private Const GMEM_ZEROINIT = &H40



Public Function ShowOpen() As Boolean
  ShowOpen = ShowOpenSave(True)
End Function
Private Function ShowOpenSave(bOpen As Boolean) As Boolean
            
Dim tOpFile As OPENFILENAME, s As String

  With tOpFile
    .lStructSize = Len(tOpFile)
    If sFileTitle = "" Then sFileTitle = vbNullChar
    If sFilter = "" Then sFilter = "Tous(*.*)|*.*"
    If lngFilterIndex = 0 Then lngFilterIndex = 1
    .hwndOwner = lnghWndOwner
    .lpstrInitialDir = sInitDir
    .lpstrDefExt = sDefaultEx
    If sDialogTitle <> "" Then .lpstrTitle = sDialogTitle
    
    ' Pour faire un style type Windows, remplacer les | par des nuls
    Dim ch As String, i As Integer
    For i = 1 To Len(sFilter)
        ch = Mid$(sFilter, i, 1)
        If ch = "|" Then
            s = s & vbNullChar
        Else
            s = s & ch
        End If
    Next
    ' Mettre un double nul  la fin
    s = s & vbNullChar & vbNullChar
    .lpstrFilter = s
    
    .nFilterIndex = lngFilterIndex

    ' Bourrer les tampons fichier et "title" fichier jusqu' la longueur maximum du chemin
    s = sFileName & String$(260 - Len(sFileName), 0)
    .lpstrFile = s
    .nMaxFile = 260
    s = sFileTitle & String$(260 - Len(sFileTitle), 0)
    .lpstrFileTitle = s
    .nMaxFileTitle = 260

    ' Passer les drapeaux, en liminant les drapeaux non VB
    .flags = lngFlags 'And &H1FF1F    'pourquoi ce And ?

    If bOpen Then
        If GetOpenFileName(tOpFile) Then
            ShowOpenSave = True
            sFileName = Left(.lpstrFile, InStr(.lpstrFile, vbNullChar) - 1)
            sFileTitle = Left(.lpstrFileTitle, InStr(.lpstrFileTitle, vbNullChar) - 1)
            sFolder = Left(sFileName, Len(sFileName) - Len(sFileTitle) - 1)
            lngFlags = .flags
        Else
            ShowOpenSave = False
            sFileName = ""
            sFileTitle = ""
            lngFlags = 0
        End If
    Else
        If GetSaveFileName(tOpFile) Then
            ShowOpenSave = True
            sFileName = Left(.lpstrFile, InStr(.lpstrFile, vbNullChar) - 1)
            sFileTitle = Left(.lpstrFileTitle, InStr(.lpstrFileTitle, vbNullChar) - 1)
            sFolder = Left(sFileName, Len(sFileName) - Len(sFileTitle) - 1)
            lngFlags = .flags
        Else
            ShowOpenSave = False
            sFileName = ""
            sFileTitle = ""
            lngFlags = 0
        End If
    
    End If
  End With
End Function

Public Function ShowSave() As Boolean
  ShowSave = ShowOpenSave(False)
End Function


Public Function ShowOpenFolder() As Boolean
Dim lngRet As Long, sDummy As String
Dim tBrowseInfo As BrowseInfo
  With tBrowseInfo
      .hwndOwner = lnghWndOwner
      .lpszTitle = lstrcat(sDialogTitle, "")
      .ulFlags = BIF_RETURNONLYFSDIRS ' + BIF_DONTGOBELOWDOMAIN
  End With
  
  lngRet = SHBrowseForFolder(tBrowseInfo)
  
  If lngRet Then
      sDummy = Space(255)
      SHGetPathFromIDList lngRet, sDummy
      sDummy = Left(sDummy, InStr(sDummy, vbNullChar) - 1)
      ShowOpenFolder = True
      sFolder = sDummy
  Else
      ShowOpenFolder = False
  End If
End Function

Public Function ShowColor() As Boolean
  Dim Custcolor(16) As Long
  Dim tColor As CHOOSECOLOR
  Dim lRet As Long
  Dim i As Integer
  
  tColor.lStructSize = Len(tColor)
  tColor.hwndOwner = lnghWndOwner
  tColor.hInstance = App.hInstance
  For i = 1 To 16
    Custcolor(16 - i) = RGB(i * 16, i * 16, i * 16)
  Next
  tColor.lCustColors = VarPtr(Custcolor(0))
  tColor.rgbResult = lngColor
  tColor.flags = lngFlags
  lRet = CHOOSECOLOR(tColor)
  If lRet <> 0 Then
    ShowColor = True
    lngColor = tColor.rgbResult
  End If
End Function

Public Function ShowFont() As Boolean
  Dim tChooseFont As CHOOSEFONT
  Dim tFont As LOGFONT
  Dim hMem As Long
  Dim pMem As Long
  Dim FontName As String
  Dim lRet As Long
  With tFont
    .lfHeight = (sngFontSize * -20) / Screen.TwipsPerPixelY
    .lfWidth = 0  '
    .lfEscapement = 0
    .lfOrientation = 0
    .lfWeight = FW_NORMAL
    .lfCharSet = DEFAULT_CHARSET
    .lfOutPrecision = OUT_DEFAULT_PRECIS
    .lfClipPrecision = CLIP_DEFAULT_PRECIS
    .lfQuality = DEFAULT_QUALITY
    .lfPitchAndFamily = DEFAULT_PITCH Or FF_ROMAN
    .lfFaceName = sFontName & vbNullChar
    If bFontBold Then
      .lfWeight = 700
    Else
      .lfWeight = 400
    End If
    .lfItalic = bFontItalic
    .lfUnderline = bFontUnderline
    .lfStrikeOut = bFontStrikethru
  End With
  ' Creation d'un boc mmoire pour servir de buffer
  hMem = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, Len(tFont))
  pMem = GlobalLock(hMem)
  CopyMemory ByVal pMem, tFont, Len(tFont)
  With tChooseFont
    .lStructSize = Len(tChooseFont)  ' size of structure
    .hwndOwner = lnghWndOwner
    .hDC = Printer.hDC  ' device context de l'imprimante(on utilise VB)
    .lpLogFont = pMem
    .iPointSize = sngFontSize * 10 '(en 10eme de points)
    .flags = lngFlags
    If lngFlags = 0 Then
      lngFlags = CF_BOTH Or CF_EFFECTS Or CF_FORCEFONTEXIST Or CF_INITTOLOGFONTSTRUCT Or CF_LIMITSIZE
    Else
      lngFlags = lngFlags Or CF_INITTOLOGFONTSTRUCT
    End If
    .flags = lngFlags
    .rgbColors = lngColor
    .nFontType = REGULAR_FONTTYPE
    .nSizeMin = 10
    .nSizeMax = 72
  End With
  lRet = CHOOSEFONT(tChooseFont)
  If lRet <> 0 Then
      CopyMemory tFont, ByVal pMem, Len(tFont)
      ShowFont = True
      With tFont
        sFontName = Left(.lfFaceName, InStr(.lfFaceName, vbNullChar) - 1)
        sngFontSize = tChooseFont.iPointSize / 10
        If .lfWeight >= 700 Then
          bFontBold = True
        Else
          bFontBold = False
        End If
        bFontItalic = .lfItalic
        bFontUnderline = .lfUnderline
        bFontStrikethru = .lfStrikeOut
        lngColor = tChooseFont.rgbColors
      End With
  End If
  ' lireation du block memoire
  lRet = GlobalUnlock(hMem)  ' destroy pointer, unlock block
  lRet = GlobalFree(hMem)  ' free the allocated memory
End Function

Public Function ShowPrinter() As Boolean
    Dim PrintDlg As PRINTDLG_TYPE
    Dim DevMode As DEVMODE_TYPE
    Dim DevName As DEVNAMES_TYPE

    Dim lpDevMode As Long, lpDevName As Long
    Dim bReturn As Integer
    Dim objPrinter As Printer, NewPrinterName As String
    
    ' Use PrintDialog to get the handle to a memory
    ' block with a DevMode and DevName structures

    PrintDlg.lStructSize = Len(PrintDlg)
    PrintDlg.hwndOwner = lnghWndOwner
    
    PrintDlg.flags = lngFlags
    If lFromPage = 0 Then lFromPage = 1
    If lToPage = 0 Then lToPage = 1
    If lMinPage = 0 Then lMinPage = lFromPage
    If lMaxPage = 0 Then lMaxPage = lToPage
    
    PrintDlg.nFromPage = lFromPage
    PrintDlg.nToPage = lToPage
    PrintDlg.nMinPage = lFromPage
    PrintDlg.nMaxPage = lToPage

    On Error Resume Next
    'Set the current orientation and duplex setting
    If sPrinterName = "" Then
      DevMode.dmDeviceName = Printer.DeviceName
    Else
      DevMode.dmDeviceName = sPrinterName
    End If
    DevMode.dmSize = Len(DevMode)
    DevMode.dmFields = DM_ORIENTATION Or DM_DUPLEX
    DevMode.dmPaperWidth = 0
    DevMode.dmOrientation = 0
    If lPaperSize = 0 Then
      DevMode.dmPaperSize = 9 'A4
    Else
      DevMode.dmPaperSize = lPaperSize
    End If
    DevMode.dmDuplex = 1    'simplex
    On Error GoTo 0

    'Allocate memory for the initialization hDevMode structure
    'and copy the settings gathered above into this memory
    PrintDlg.hDevMode = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, Len(DevMode))
    lpDevMode = GlobalLock(PrintDlg.hDevMode)
    If lpDevMode > 0 Then
        CopyMemory ByVal lpDevMode, DevMode, Len(DevMode)
        bReturn = GlobalUnlock(PrintDlg.hDevMode)
    End If

    'Set the current driver, device, and port name strings
    With DevName
        .wDriverOffset = 8
        .wDeviceOffset = .wDriverOffset + 1 + Len(Printer.DriverName)
        .wOutputOffset = .wDeviceOffset + 1 + Len(Printer.Port)
        .wDefault = 0
    End With

    With Printer
        DevName.extra = .DriverName & Chr(0) & .DeviceName & Chr(0) & .Port & Chr(0)
    End With

    'Allocate memory for the initial hDevName structure
    'and copy the settings gathered above into this memory
    PrintDlg.hDevNames = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, Len(DevName))
    lpDevName = GlobalLock(PrintDlg.hDevNames)
    If lpDevName > 0 Then
        CopyMemory ByVal lpDevName, DevName, Len(DevName)
        bReturn = GlobalUnlock(lpDevName)
    End If

    'Call the print dialog up and let the user make changes
    If PrintDialog(PrintDlg) <> 0 Then
        'First get the DevName structure.
        lpDevName = GlobalLock(PrintDlg.hDevNames)
        CopyMemory DevName, ByVal lpDevName, 45
        bReturn = GlobalUnlock(lpDevName)
        GlobalFree PrintDlg.hDevNames

        'Next get the DevMode structure and set the printer
        'properties appropriately
        lpDevMode = GlobalLock(PrintDlg.hDevMode)
        CopyMemory DevMode, ByVal lpDevMode, Len(DevMode)
        bReturn = GlobalUnlock(PrintDlg.hDevMode)
        GlobalFree PrintDlg.hDevMode
        sPrinterName = UCase$(Left(DevMode.dmDeviceName, InStr(DevMode.dmDeviceName, Chr$(0)) - 1))
        lCopies = DevMode.dmCopies
        lFromPage = PrintDlg.nFromPage
        lToPage = PrintDlg.nToPage
        lPaperSize = DevMode.dmPaperSize
        lDuplex = DevMode.dmDuplex
        lPaperBin = DevMode.dmDefaultSource
        lOrientation = DevMode.dmOrientation
        lColorMode = DevMode.dmColor
        ShowPrinter = True
    End If

End Function
'//****************LES PROPRIETES**************************


Property Get Folder() As String
    Folder = sFolder
End Property

Property Get FileName() As String
    FileName = sFileName
End Property

Property Let FileName(sFileNameA As String)
    sFileName = sFileNameA
End Property

Property Get DialogTitle() As String
    DialogTitle = sDialogTitle
End Property

Property Let DialogTitle(sDialogTitleA As String)
    sDialogTitle = sDialogTitleA
End Property

Property Get flags() As CdlgConst
    flags = lngFlags
End Property

Property Let flags(lngFlagsA As CdlgConst)
    lngFlags = lngFlagsA
End Property

Property Get hwndOwner() As Long
    hwndOwner = lnghWndOwner
End Property

Property Let hwndOwner(lnghWndOwnerA As Long)
    lnghWndOwner = lnghWndOwnerA
End Property


Property Get Filter() As String
    Filter = sFilter
End Property

Property Let Filter(sFilterA As String)
    sFilter = sFilterA
End Property

Property Get FilterIndex() As Long
    FilterIndex = lngFilterIndex
End Property

Property Let FilterIndex(lngFilterIndexA As Long)
    lngFilterIndex = lngFilterIndexA
End Property

Property Get InitDir() As String
    InitDir = sInitDir
End Property

Property Let InitDir(sInitDirA As String)
    sInitDir = sInitDirA
End Property


Property Get FileTitle() As String
    FileTitle = sFileTitle
End Property


Property Get DefaultEx() As String
    DefaultEx = sDefaultEx
End Property

Property Let DefaultEx(sDefaultExA As String)
    sDefaultEx = sDefaultExA
End Property

Public Property Get Color() As OLE_COLOR
  Color = lngColor
End Property

Public Property Let Color(lngColorA As OLE_COLOR)
  lngColor = lngColorA
End Property

Public Property Get FontName() As String
  FontName = sFontName
End Property

Public Property Let FontName(ByVal sFontNameA As String)
  sFontName = sFontNameA
End Property

Public Property Get FontSize() As Single
  FontSize = sngFontSize
End Property

Public Property Let FontSize(ByVal sngFontSizeA As Single)
  sngFontSize = sngFontSizeA
End Property

Public Property Get FontBold() As Boolean
  FontBold = bFontBold
End Property

Public Property Let FontBold(ByVal bFontBoldA As Boolean)
  bFontBold = bFontBoldA
End Property

Public Property Get FontItalic() As Boolean
  FontItalic = bFontItalic
End Property

Public Property Let FontItalic(ByVal bFontItalicA As Boolean)
  bFontItalic = bFontItalicA
End Property

Public Property Get FontUnderline() As Boolean
  FontUnderline = bFontUnderline
End Property

Public Property Let FontUnderline(ByVal bFontUnderlineA As Boolean)
  bFontUnderline = bFontUnderlineA
End Property

Public Property Get FontStrikeThru() As Boolean
  FontStrikeThru = bFontStrikethru
End Property

Public Property Let FontStrikeThru(ByVal bFontStrikeThruA As Boolean)
  bFontStrikethru = bFontStrikeThruA
End Property

Public Property Get FromPage() As Long
  FromPage = lFromPage
End Property

Public Property Let FromPage(ByVal vNewValue As Long)
  lFromPage = vNewValue
End Property

Public Property Get ToPage() As Long
  ToPage = lToPage
End Property

Public Property Let ToPage(ByVal vNewValue As Long)
  lToPage = vNewValue
End Property

Public Property Get MinPage() As Long
  MinPage = lMinPage
End Property

Public Property Let MinPage(ByVal vNewValue As Long)
  lMinPage = vNewValue
End Property

Public Property Get MaxPage() As Long
  MaxPage = lMaxPage
End Property

Public Property Let MaxPage(ByVal vNewValue As Long)
  lMaxPage = vNewValue
End Property

Public Property Get Copies() As Long
  Copies = lCopies
End Property

Public Property Let Copies(ByVal vNewValue As Long)
  lCopies = vNewValue
End Property


Public Property Get PaperSize() As Long
  PaperSize = lPaperSize
End Property

Public Property Let PaperSize(ByVal vNewValue As Long)
  lPaperSize = vNewValue
End Property

Public Property Get Duplex() As Long
  Duplex = lDuplex
End Property

Public Property Let Duplex(ByVal vNewValue As Long)
  lDuplex = vNewValue
End Property

Public Property Get PaperBin() As Long
  PaperBin = lPaperBin
End Property

Public Property Let PaperBin(ByVal vNewValue As Long)
  lPaperBin = vNewValue
End Property

Public Property Get Orientation() As Variant
  Orientation = lOrientation
End Property

Public Property Let Orientation(ByVal vNewValue As Variant)
  lOrientation = vNewValue
End Property

Public Property Get PrintQuality() As Long
  PrintQuality = lPrintQuality
End Property

Public Property Let PrintQuality(ByVal vNewValue As Long)
  lPrintQuality = vNewValue
End Property

Public Property Get ColorMode() As Long
  ColorMode = lColorMode
End Property

Public Property Let ColorMode(ByVal vNewValue As Long)
  lColorMode = vNewValue
End Property

Public Property Get PrinterName() As String
  PrinterName = sPrinterName
End Property

Public Property Let PrinterName(ByVal vNewValue As String)
  sPrinterName = vNewValue
End Property
